﻿Imports System.Net
Imports System.Net.Sockets
Imports System.Text

Public Class Form1

    Dim TCP_Server As Socket
    Dim TCP_Listener As Socket
    Dim restartListener As Boolean = False

    Dim receiveBuffer(512) As Byte
    Dim receiveString As String

    Private Delegate Sub DelegateSub()

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        closeConnection()

    End Sub


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Me.gb_io.Enabled = False
        Me.bt_listenstop.Enabled = False
        Me.sb_status.Text = "no connection"

    End Sub

    Private Sub callback_accept(ByVal ar As IAsyncResult)

        Try

            TCP_Server = TCP_Listener.EndAccept(ar)

            Me.sb_status.Text = "connected"


            Me.Invoke(New DelegateSub(AddressOf Listendisable))
            Me.Invoke(New DelegateSub(AddressOf controlsenable))

            TCP_Server.BeginReceive(receiveBuffer, 0, 512, SocketFlags.None, New AsyncCallback(AddressOf callback_receive), TCP_Server)

            sendCmd("GET /output?PW=" + ed_Password.Text + "&")
            sendCmd("GET /counter?PW=" + ed_Password.Text + "&")

        Catch ex As ObjectDisposedException

        Catch ex As Exception
            closeConnection()
            Me.sb_status.Text = "Error while connecting!"
        End Try

    End Sub

    Private Sub callback_receive(ByVal ar As IAsyncResult)

        Dim receiveCount As Integer

        Try
            If Not TCP_Server Is Nothing Then
                If TCP_Server.Connected Then
                    receiveCount = TCP_Server.EndReceive(ar)
                    receiveString = Encoding.ASCII.GetString(receiveBuffer)
                    Array.Clear(receiveBuffer, 0, 512)
                    Me.Invoke(New DelegateSub(AddressOf evaluateResponse))
                    TCP_Server.BeginReceive(receiveBuffer, 0, 512, SocketFlags.None, New AsyncCallback(AddressOf callback_receive), TCP_Server)
                End If
            End If
        Catch ex As Exception
            Me.sb_status.Text = "Error while receiving!"
        End Try

        If receiveCount = 0 Then
            closeConnection()
        End If

    End Sub

    Private Sub closeConnection()

        Try
            If Not TCP_Server Is Nothing Then
                If TCP_Server.Connected Then
                    TCP_Server.Shutdown(SocketShutdown.Both)
                    TCP_Server.Close()
                    TCP_Server = Nothing
                End If
            End If

            Me.sb_status.Text = "no connection"

            If restartListener = True Then
                Me.TCP_Listener.Listen(1)
                Me.TCP_Listener.BeginAccept(New AsyncCallback(AddressOf callback_accept), TCP_Listener)
            End If

            Me.Invoke(New DelegateSub(AddressOf controlsdisable))
        Catch ex As Exception
            Me.sb_status.Text = "Error while disconnecting!"
        End Try

    End Sub

    Private Sub Listendisable()

        Me.bt_listenstop.Enabled = True
        Me.bt_listen.Enabled = False

    End Sub

    Private Sub listenenable()

        Me.bt_listenstop.Enabled = False
        Me.bt_listen.Enabled = True

    End Sub

    Private Sub controlsenable()

        Me.gb_io.Enabled = True

    End Sub

    Private Sub controlsdisable()

        Me.gb_io.Enabled = False

    End Sub

    Private Sub evaluateResponse()

        Dim seperator() As Char = {";"}

        Try

            Select Case receiveString.Substring(0, 1)
                Case "i"
                    Dim inputValue As Integer = Convert.ToInt16(receiveString.Substring(6, 4), 16)

                    For port As Integer = 0 To 11
                        If inputValue And 2 ^ port Then
                            CType(Me.Controls.Find("cb_input" & port, True)(0), CheckBox).Checked = True
                        Else
                            CType(Me.Controls.Find("cb_input" & port, True)(0), CheckBox).Checked = False
                        End If
                    Next


                Case "o"
                    Dim outputValue As Integer = Convert.ToInt16(receiveString.Substring(7, 4), 16)

                    For port As Integer = 0 To 11
                        If outputValue And 2 ^ port Then
                            CType(Me.Controls.Find("cb_output" & port, True)(0), CheckBox).Checked = True
                        Else
                            CType(Me.Controls.Find("cb_output" & port, True)(0), CheckBox).Checked = False
                        End If
                    Next

                Case "c"
                    If receiveString.IndexOf(";") = 7 Then
                        Dim values() As String = receiveString.Split(seperator)

                        For port As Integer = 0 To 11
                            CType(Me.Controls.Find("ed_counter" & port, True)(0), TextBox).Text = values(port + 1)
                        Next
                    Else
                        Dim port As Integer = receiveString.Substring(7, receiveString.IndexOf(";") - 7)
                        Dim value As Integer = receiveString.Substring(receiveString.IndexOf(";") + 1)
                        CType(Me.Controls.Find("ed_counter" & port, True)(0), TextBox).Text = value
                    End If
            End Select

        Catch ex As Exception
            Me.sb_status.Text = "Error while receiving"
        End Try

    End Sub

    Private Sub ed_interval_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ed_interval.TextChanged

        Me.Timer_polling.Interval = Val(Me.ed_interval.Text)

    End Sub

    Private Sub sendCmd(ByVal cmd As String)

        Try

            Dim cmdBytes As Byte()
            cmdBytes = Encoding.ASCII.GetBytes(cmd)
            TCP_Server.Send(cmdBytes, cmdBytes.Length, SocketFlags.None)

        Catch ex As Exception
            Me.sb_status.Text = "Error while sending command!"
        End Try

    End Sub

    Private Sub cb_output_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cb_output0.Click, cb_output1.Click, cb_output9.Click, cb_output8.Click, cb_output7.Click, cb_output6.Click, cb_output5.Click, cb_output4.Click, cb_output3.Click, cb_output2.Click, cb_output11.Click, cb_output10.Click

        Dim Cur_cb As CheckBox = sender
        Dim CurOutputNo As Integer

        If Cur_cb.Name.Length = 10 Then
            CurOutputNo = Cur_cb.Name.Substring(9, 1)
        Else
            CurOutputNo = Cur_cb.Name.Substring(9, 2)
        End If

        If Cur_cb.Checked Then
            sendCmd("GET /outputaccess" & CurOutputNo & "?PW=" & ed_Password.Text & "&State=ON&")
        Else
            sendCmd("GET /outputaccess" & CurOutputNo & "?PW=" & ed_Password.Text & "&State=OFF&")
        End If

    End Sub

    Private Sub bt_outputs_read_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_outputs_read.Click

        sendCmd("GET /output?PW=" + ed_Password.Text + "&")

    End Sub

    Private Sub bt_inputs_read_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_inputs_read.Click

        sendCmd("GET /input?PW=" + ed_Password.Text + "&")

    End Sub

    Private Sub bt_conter_readall_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_conter_readall.Click

        sendCmd("GET /counter?PW=" + ed_Password.Text + "&")

    End Sub

    Private Sub bt_counter_clearall_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_counter_clearall.Click

        sendCmd("GET /counterclear?PW=" + ed_Password.Text + "&")

    End Sub

    Private Sub bt_counter_read_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_counter_read0.Click, bt_counter_read1.Click, bt_counter_read9.Click, bt_counter_read8.Click, bt_counter_read7.Click, bt_counter_read6.Click, bt_counter_read5.Click, bt_counter_read4.Click, bt_counter_read3.Click, bt_counter_read2.Click, bt_counter_read11.Click, bt_counter_read10.Click

        Dim Cur_bt As Button = sender
        Dim CurCounterNo As Integer

        If Cur_bt.Name.Length = 16 Then
            CurCounterNo = Cur_bt.Name.Substring(15, 1)
        Else
            CurCounterNo = Cur_bt.Name.Substring(15, 2)
        End If

        sendCmd("GET /counter" & CurCounterNo.ToString & "?PW=" & ed_Password.Text & "&")

    End Sub

    Private Sub bt_counter_clear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_counter_clear0.Click, bt_counter_clear1.Click, bt_counter_clear4.Click, bt_counter_clear3.Click, bt_counter_clear2.Click, bt_counter_clear9.Click, bt_counter_clear8.Click, bt_counter_clear7.Click, bt_counter_clear6.Click, bt_counter_clear5.Click, bt_counter_clear11.Click, bt_counter_clear10.Click

        Dim Cur_bt As Button = sender
        Dim CurCounterNo As Integer

        If Cur_bt.Name.Length = 17 Then
            CurCounterNo = Cur_bt.Name.Substring(16, 1)
        Else
            CurCounterNo = Cur_bt.Name.Substring(16, 2)
        End If

        sendCmd("GET /counterclear" & CurCounterNo & "?PW=" & ed_Password.Text & "&")

    End Sub

    Private Sub Timer_polling_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer_polling.Tick

        If Not TCP_Server Is Nothing Then
            If TCP_Server.Connected Then
                If cb_output_polling.Checked Then
                    sendCmd("GET /output?PW=" + ed_Password.Text + "&")
                End If
                If cb_input_polling.Checked Then
                    sendCmd("GET /input?PW=" + ed_Password.Text + "&")
                End If
                If cb_counter_polling.Checked Then
                    sendCmd("GET /counter?PW=" + ed_Password.Text + "&")
                End If
            End If
        End If

    End Sub

    Private Sub bt_listen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_listen.Click

        If Me.ed_Port.Text <> "" Then
            Try

                Dim LocalEP As New IPEndPoint(IPAddress.Any, Val(Me.ed_Port.Text))
                TCP_Listener = New Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp)

                TCP_Listener.Bind(LocalEP)
                TCP_Listener.Listen(1)

                TCP_Listener.BeginAccept(New AsyncCallback(AddressOf callback_accept), TCP_Listener)

                Me.Invoke(New DelegateSub(AddressOf Listendisable))
                restartListener = True

            Catch ex As Exception
                closeConnection()
                Me.sb_status.Text = "Error while starting listener!"
            End Try
        Else
            Me.sb_status.Text = "Port needed!"
        End If

    End Sub

    Private Sub bt_listenstop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_listenstop.Click

        Try
            restartListener = False
            TCP_Listener.Close()
            closeConnection()
            listenenable()
        Catch ex As Exception
            Me.sb_status.Text = "Error while stopping listener!"
        End Try

    End Sub
End Class
